/*
 * 文件名: InitListener.java
 * 版    权：  Copyright Changwan Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: turlet@163.com
 * 创建时间:2013-5-9
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.listener;

import java.net.URLDecoder;

import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;
import cn.ewan.pushsdk.logic.CacheData;
import cn.ewan.pushsdk.model.ResponseInit;
import cn.ewan.pushsdk.net.IHttpListener;
import cn.ewan.pushsdk.util.Common;
import cn.ewan.pushsdk.util.ErrorCode;
import cn.ewan.pushsdk.util.JsonUtil;
import cn.ewan.pushsdk.util.LogUtil;
import cn.ewan.pushsdk.util.StringUtil;

/**
 * [EwanPushSdk初始化返回数据]<BR>
 * [功能详细描述]
 * @author panyf
 * @version [Client V100R001C03, 2016-3-31] 
 */
public class InitListener implements IHttpListener {
    Context context;
    
    private Callback callback;
    
    public InitListener(Context context, Callback callback) {
        super();
        this.context = context;
        this.callback = callback;
    }
    
    @Override
    public void onComplete(String ret, Object obj) {
        if (!StringUtil.isEmpty(ret)) {
            try {
                ret = URLDecoder.decode(ret, Common.ENC_UTF_8);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
            JSONObject jsonObj = new JSONObject(ret);
            int status = jsonObj.getInt("ret_code");

            if (ErrorCode.STATUS_SUCCESS_CODE == status) {//成功
            	LogUtil.i("", "jsonObj =="+jsonObj.toString());
            	ResponseInit init = new ResponseInit(jsonObj.getJSONObject("result"));
                init.setStatus(status);
                init.setAdress(init.getAdress());
                init.setCliendId(init.getCliendId());
                init.setSecretKey(init.getSecretKey());
                CacheData.getInstance().setClientId(context, init.getCliendId());
                CacheData.getInstance().setUri(context, "tcp://"+init.getAdress());
                CacheData.getInstance().setContentKey(context, init.getSecretKey());
                callback.onSuccess(init);
            }
            else {//失败
            	ResponseInit init = new ResponseInit();
                init.setStatus(status);
                init.setErrorMsg(jsonObj.getString("err_msg"));
                CacheData.getInstance().clear(context);
                callback.onFail(init.getStatus(), init.getErrorMsg());
            }
            
        }
        catch (JSONException e) {
            e.printStackTrace();
            callback.onFail(ErrorCode.ERROR_JSON_PARSE, e.getMessage());
        }
    }
    
    @Override
    public void onException(int errorCode, Exception ex) {
        callback.onFail(errorCode, ex.getMessage());
    }
 
}
