/*
 * 文件名: NormalListener.java
 * 版    权：  Copyright Changwan Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: turlet@163.com
 * 创建时间:2013-5-10
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.listener;

import java.net.URLDecoder;

import org.json.JSONException;
import org.json.JSONObject;

import android.content.Context;
import cn.ewan.pushsdk.model.Response;
import cn.ewan.pushsdk.net.IHttpListener;
import cn.ewan.pushsdk.util.Common;
import cn.ewan.pushsdk.util.ErrorCode;
import cn.ewan.pushsdk.util.StringUtil;

/**
 * [普通监听返回数据解释]<BR>
 * [只是判断数据正确返回1和错误码]
 * @author panyf
 * @version [Client V100R001C03, 2016-3-31] 
 */
public class NormalListener implements IHttpListener {
    
    Context context;
    
    private Callback callback;
    
    public NormalListener(Context context, Callback callback) {
        super();
        this.context = context;
        this.callback = callback;
    }
    
    @Override
    public void onComplete(String ret, Object obj) {
        
        if (!StringUtil.isEmpty(ret)) {
            try {
                ret = URLDecoder.decode(ret, Common.ENC_UTF_8);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        try {
            JSONObject jsonObj = new JSONObject(ret);
            int status = jsonObj.getInt("ret_code");
            Response response = new Response();
            response.setStatus(status);
            if (ErrorCode.STATUS_SUCCESS_CODE == status) {//成功
                callback.onSuccess(response);
            }
            else {//失败
                response.setErrorMsg(jsonObj.getString("ret_code"));
                callback.onFail(response.getStatus(), response.getErrorMsg());
            }
            
        }
        catch (JSONException e) {
            e.printStackTrace();
            callback.onFail(ErrorCode.ERROR_JSON_PARSE, e.getMessage());
        }
    }
    
    @Override
    public void onException(int errorCode, Exception ex) {
        callback.onFail(errorCode, ex.getMessage());
    }
    
}
