/*
 * 文件名: CacheData.java
 * 版    权：  Copyright Changwan Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: turlet@163.com
 * 创建时间:2013-5-10
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.logic;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.content.Context;
import cn.ewan.pushsdk.util.LogUtil;
import cn.ewan.pushsdk.util.SPUtil;
import cn.ewan.pushsdk.util.StringUtil;

/**
 * [一些临时数据缓存]<BR>
 * [功能详细描述]
 * @author turlet@163.com
 * @version [Client V100R001C03, 2013-5-10] 
 */
public class CacheData {
    
    private static CacheData instance;
    
    private String uri;
    
    private String clientId;
    
    private String contentKey;
    
    private String protocolKey;
    
    private CacheData() {
        super();
    }
    
    public synchronized static CacheData getInstance() {
        if (null == instance) {
            instance = new CacheData();
        }
        return instance;
    }
    
    public String getClientId(Context context) {
    	
    	clientId = SPUtil.getInstance(context)
                .getString(SPUtil.usertoken);
    	
        return clientId;
    }
    
    public void setClientId(Context context, String token) {
        if (null != token) {
            SPUtil.getInstance(context).saveString(SPUtil.usertoken, token);
        }
        else {
            SPUtil.getInstance(context).saveString(SPUtil.usertoken, "");
        }
        this.clientId = token;
    }
    
    /**
	 * @return uri
	 */
	public String getUri(Context context)
	{
		uri = SPUtil.getInstance(context)
                .getString(SPUtil.uri);
		return uri;
	}

	/**
	 * @param uri 要设置的 uri
	 */
	public void setUri(Context context, String uri)
	{
        if (null != uri) {
            SPUtil.getInstance(context).saveString(SPUtil.uri, uri);
        }
        else {
            SPUtil.getInstance(context).saveString(SPUtil.uri, "");
        }
		this.uri = uri;
	}

	public String getContentKey(Context context) {
    	
    	contentKey = SPUtil.getInstance(context).getString(SPUtil.key);

        return contentKey;
    }
    
    public void setContentKey(Context context, String key) {
        //只保存加密key、url，callback
        if (null != key) {
            SPUtil.getInstance(context).saveString(SPUtil.key, key);
        }
        else {
            SPUtil.getInstance(context).saveString(SPUtil.key, "");
        }
        this.contentKey = key;
    }
    
    
	public void saveTopics(Context context,String topics)
	{
		String temp = SPUtil.getInstance(context).getString(SPUtil.topics);
		
		LogUtil.i("", "saveTopics temp===="+temp);
		StringBuilder saveStr = new StringBuilder();
		if(!StringUtil.isEmpty(temp)){
			String array[] = temp.split(",");
			List<String> packnameList = new ArrayList<String>();
			packnameList.addAll(Arrays.asList(array));
			if(!packnameList.contains(topics)){
				saveStr.append(temp).append(topics).append(",");
				LogUtil.i("", "saveTopics saveStr===="+saveStr.toString());
				SPUtil.getInstance(context).saveString(SPUtil.topics, saveStr.toString());
			}
		}else{
			saveStr.append(topics).append(",");
			LogUtil.i("", "saveTopics saveStr===="+saveStr.toString());
			SPUtil.getInstance(context).saveString(SPUtil.topics, saveStr.toString());
		}
	}
    
	public String getTopics(Context context){
		String temp = SPUtil.getInstance(context).getString(SPUtil.topics);
		return temp;
	}
	
	public void removeTopics(Context context,String topics)
	{
		String temp = SPUtil.getInstance(context).getString(SPUtil.topics);
		if(!StringUtil.isEmpty(temp)){
			String array[] = temp.split(",");
			List<String> packnameList = new ArrayList<String>();
			packnameList.addAll(Arrays.asList(array));
			if(packnameList.contains(topics)){
				packnameList.remove(topics);
			}
			
	        String[] newStr =  packnameList.toArray(new String[1]);  
	        String saveStr = "";
	                
	        for (int j = 0; j < newStr.length; j++) {
	        	if(newStr[j] != null){
	        		saveStr += newStr[j] + ",";	
	        	}	
	        }

/*	        if(!StringUtil.isEmpty(saveStr)){
	        	saveStr = saveStr.substring(0, saveStr.length() - 1);
	        }*/
	        LogUtil.i("", "removeTopics saveStr===="+saveStr);
			SPUtil.getInstance(context).saveString(SPUtil.topics, saveStr);
		}		
	}
	
	
	
    /**
	 * @return protocolKey
	 */
	public String getProtocolKey(Context ctx)
	{
		protocolKey = SPUtil.getInstance(ctx).getString(SPUtil.protocolkey);
		return protocolKey;
	}

	/**
	 * @param protocolKey 要设置的 protocolKey
	 */
	public void setProtocolKey(Context ctx, String protocolKey)
	{
        if (null != protocolKey) {
            SPUtil.getInstance(ctx).saveString(SPUtil.protocolkey, protocolKey);
        }
        else {
            SPUtil.getInstance(ctx).saveString(SPUtil.protocolkey, "");
        }
		this.protocolKey = protocolKey;
	}

	/**
     * [退出清除数据]<BR>
     * [功能详细描述]
     * @param context
     */
    public void clear(Context context) {
    	setClientId(context, null);
        setContentKey(context, null);
        SPUtil.getInstance(context).saveString(SPUtil.topics, "");
    }
}
