/*
 * 文件名: UnionService.java
 * 版    权：  Copyright Changwan Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: turlet@163.com
 * 创建时间:2013-5-8
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.logic;

import java.util.Map;

import android.content.Context;
import cn.ewan.pushsdk.listener.Callback;
import cn.ewan.pushsdk.listener.InitListener;
import cn.ewan.pushsdk.listener.NormalListener;
import cn.ewan.pushsdk.net.AsyncHttpPostTask;
import cn.ewan.pushsdk.net.HttpAssemble;
import cn.ewan.pushsdk.net.IHttpListener;
import cn.ewan.pushsdk.util.Common;

/**
 * [联运SDK的所有业务接口]<BR>
 * [功能详细描述]
 * @author turlet@163.com
 * @version [Client V100R001C03, 2013-5-8] 
 */
public class EwanPushService {
    
    private static final String TAG = EwanPushService.class.getSimpleName();
    
    
    /**
     * [初始化]<BR>
     * [功能详细描述]
     * @param [context]
     * @param [callback]
     */
    public static void init(Context context, 
    		String appId, 
    		String appKey,
    		String url,
    		String userId,
    		Callback callback) {
    	
    	CacheData.getInstance().clear(context);
    	
        Map<String, String> params = HttpAssemble.getPublicParams(context);
        params.put("accessid", appId);//应用版本
        params.put("accesskey", appKey);//联网类型
        params.put("userid", userId);

        asyncPost(context,
        		url,
                params,
                true,
                new InitListener(context, callback));
    }
    
    /**
     * 绑定账号<BR>
     * [功能详细描述]
     * @param [context]
     * @param [login] 登录信息对象
     * @param [callback]
     */
    
    public static void bindAccount(Context context, 
    		String appId, 
    		String userId,
    		String url,
    		Callback callback) {
        Map<String, String> params =  HttpAssemble.getPublicParams(context);
        params.put("accessid", appId);
        params.put("username", userId);
        
        asyncPost(context, 
        		url,
        		params, 
        		true,
        		new NormalListener(context, callback));
    }
        
    /**
     * 
     * 其它网络请求异步统一出口<BR>
     * [功能详细描述]
     * @param [context]
     * @param [url] 访问的URL地址
     * @param [params] 参数
     * @param [encryption] 数据是否加密发送
     * @param [listener]
     */
    private static void asyncPost(Context context, String url,
            Map<String, String> params, boolean encryption,
            IHttpListener listener) {
        new AsyncHttpPostTask().request(context,
                url,
                params,
                null,
                null,
                listener,
                Common.ENC_UTF_8,
                encryption);
    }
        
}
