/*
 *                    _ooOoo_
 *                   o8888888o
 *                   88" . "88
 *                   (| -_- |)
 *                   O\  =  /O
 *                ____/`---'\____
 *              .'  \\|     |//  `.
 *             /  \\|||  :  |||//  \
 *            /  _||||| -:- |||||-  \
 *            |   | \\\  -  /// |   |
 *            | \_|  ''\---/''  |   |
 *            \  .-\__  `-`  ___/-. /
 *          ___`. .'  /--.--\  `. . __
 *       ."" '<  `.___\_<|>_/___.'  >'"".
 *      | | :  `- \`.;`\ _ /`;.`/ - ` : | |
 *      \  \ `-.   \_ __\ /__ _/   .-` /  /
 * ======`-.____`-.___\_____/___.-`____.-'======
 *                    `=---='
 * ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
 *                 佛祖保佑       永无BUG
 */
package cn.ewan.pushsdk.net;

import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;

import android.content.Context;
import android.util.Log;
import cn.ewan.pushsdk.logic.CacheData;
import cn.ewan.pushsdk.open.EwanPushClient;
import cn.ewan.pushsdk.util.AES;
import cn.ewan.pushsdk.util.Common;
import cn.ewan.pushsdk.util.DeviceInfo;
import cn.ewan.pushsdk.util.MD5;
import cn.ewan.pushsdk.util.RootUtil;
import cn.ewan.pushsdk.util.StringUtil;

/**
 * http请求组装类
 * <p>
 * 【类详情描述】
 * 
 * @since 1.0
 * @version 2016-3-29
 * @author panyf
 * 
 */
public class HttpAssemble {

	/** 系统平台（1为Android，2为iOS,3为WP） */
	public static final String PLATFORM_ID = "1";

	/** 1是越狱，2是正版,安卓的填0 */
	public static final String IOS_FLAG = "0";

	private static int isRoot = -1;
	private static String packetname;
	private static String devicecode;
	private static String devicename;
	private static String devicemanufacturer;
	private static String mac;
	private static String imsi;
	private static String imei;
	private static String resolution;
	private static String osversion;
	private static String versionid;
	private static String versioncode;
	private static String sdkversionid;

	static {
		isRoot = RootUtil.isRootSystem() ? 1 : 0;
	}

	/**
	 * @return the {@link #versioncode}
	 */
	public static String getVersioncode() {
		return versioncode;
	}

	/**
	 * 获取协议接口公共传参
	 * 
	 * @return the params
	 */
	public static Map<String, String> getPublicParams(Context context) {
		Map<String, String> params = new HashMap<String, String>();

		long timestamp = System.currentTimeMillis();
		String mToken = "";

		if (StringUtil.isEmpty(devicecode)) {
			devicecode = DeviceInfo.getDeviceID(context);
		}
		if (StringUtil.isEmpty(devicename)) {
			devicename = DeviceInfo.getModel();
		}
		if (StringUtil.isEmpty(devicemanufacturer)) {
			devicemanufacturer = DeviceInfo.getMake();
		}
		if (StringUtil.isEmpty(mac) || "0:0:0:0:0:0".equals(mac)) {
			mac = DeviceInfo.getMacAddress(context);
		}
		if (StringUtil.isEmpty(imsi)) {
			imsi = DeviceInfo.getIMSI(context);
		}
		if (StringUtil.isEmpty(imei)) {
			imei = DeviceInfo.getIMEI(context);
		}
		if (StringUtil.isEmpty(resolution) || "0*0".equals(resolution)) {
			resolution = DeviceInfo.getResolution(context);
		}
		if (StringUtil.isEmpty(osversion)) {
			osversion = DeviceInfo.getSysVersion();
		}

		if (StringUtil.isEmpty(versionid)) {
			versionid = String.valueOf(DeviceInfo.getAppVersion(context));
		}
		if (StringUtil.isEmpty(versioncode)) {
			versioncode = DeviceInfo.getAppVersionName(context);
		}
		if (StringUtil.isEmpty(sdkversionid)) {
			sdkversionid = Common.sdkVersionCode+"";
		}

		if (isRoot == -1) {
			isRoot = RootUtil.isRootSystem() ? 1 : 0;
		}
		
		/* 设备信息 */
		params.put("devicecode", devicecode); // 设备号,iOS为mac
		params.put("devicename", devicename); // 设备名称,手机型号
		params.put("devicemanufacturer", devicemanufacturer); // 设备厂商
		params.put("imei", imei); // IMEI
		params.put("mac", mac); // mac地址l
		params.put("imsi", imsi); // sim卡imsi
		params.put("resolution", resolution); // 设备分辨率
		params.put("platformid", PLATFORM_ID); // 系统平台（1为Android，2为iOS,3为WP）
		params.put("osversion", osversion); // 系统版本

		/* 设置信息 */
		// TODO: 语言？
		params.put("languageid", "2"); // 语言,1:英语,2:简体中文,3:繁体中文
		params.put("connectiontype", DeviceInfo.getNetWorkType(context)); // 联网类型

		/* app信息 */
		params.put("packetname", context.getPackageName()); // 产品包名
		params.put("versionid", versionid); // 产品版本ID
		params.put("versioncode", versioncode); // 产品版本号
		
		/*sdk版本号 */
		params.put("sdkversionid", sdkversionid); 

		mToken = CacheData.getInstance().getClientId(context);
		
		/* 协议连接信息 */
		if(StringUtil.isEmpty(mToken)){	
			mToken = "0";
		}
		
		params.put("token", mToken); // 空表示没登录

		/* 其他 */
		params.put("timestamp", String.valueOf(timestamp)); // 时间戳
		params.put(
				"sign",
				getVerifier("packetname="+context.getPackageName(), 
						"versioncode="+versioncode, 
						"devicecode="+devicecode,
						"timestamp="+timestamp,
						"token="+mToken,
						CacheData.getInstance().getProtocolKey(context))); 
		params.put("isroot", Integer.toString(isRoot));

		return params;
	}

	/**
	 * 校验码MD5
	 * 
	 * @param params
	 *            校验参数数组
	 * @return
	 */
	public static String getVerifier(String... params) {
		String verifier = "";
		if (params != null) {
			StringBuilder sb = new StringBuilder();
			for (String string : params) {
				if (sb.length() > 0)
					sb.append("&");
				sb.append(string);
			}
			try {
				Log.i("", "verifier ========"+sb.toString());
				verifier = MD5.toMD5(sb.toString());
			} catch (Exception e) {
				e.printStackTrace();
				verifier = "";
			}
		}
		Log.i("", "MD5 verifier ========"+verifier);
		return verifier;
	}

	/**
	 * 判断静默安装 返回0是有权限 -1手机没有root权限
	 * 
	 * @param context
	 * @return
	 * @deprecated 会卡住
	 */
	public static int hasRooted() {
		Process process = null;
		PrintStream printStream;
		try {
			process = Runtime.getRuntime().exec("su");
			printStream = new PrintStream(process.getOutputStream());
			printStream.println("exit");
			int code = process.waitFor();
			return code;
		} catch (Exception e) {
			return -1;
		}
	}

/*	*//**
	 * 获取反馈请求参数
	 * 
	 * @param context
	 * @return
	 *//*
	public static String getFeedbackParams(Context context) {
		String feedbackParams = "";
		Map<String, String> params = new HashMap<String, String>();
		String productid = GameBoxConfig.PRODUCT_ID;
		if (StringUtil.isEmpty(packetid)) {
			packetid = GameBoxConfig.getPacketID(context);
		}
		if (StringUtil.isEmpty(versionid)) {
			versionid = String.valueOf(DeviceInfo.getAppVersion(context));
		}
		if (StringUtil.isEmpty(sysuserid) || sysuserid.equals("0")) {
			sysuserid = String.valueOf(GameBoxApplication.getSysUserID());
		}
		if (StringUtil.isEmpty(devicekey)) {
			devicekey = GameBoxConfig.getDeviceKey();
		}
		String userid = "";
		if (!GameBoxApplication.getToken().isEmpty()) {
			UserInfoBean userInfoBean = GameBoxApplication.getUserInfo();
			if (userInfoBean != null) {
				userid = Long.toString(userInfoBean.getUserID());
			}
		}

		params.put("productid", productid); // 产品ID
		params.put("packetid", packetid); // 渠道包ID
		params.put("versionid", versionid); // 产品版本ID
		params.put("sysuserid", sysuserid); // 若sysuserid为0，则是首次使用，需要注册(BaseUser表)
		params.put("userid", userid);
		params.put("devicekey", devicekey); // 客户端唯一标识,第一次初始化为空

		try {
			feedbackParams = encodeUrl(params,
					GBResponseHandler.DEFAULT_ENCODING, true,
					GameBoxApplication.getEncryptKey());
		} catch (UnsupportedEncodingException e) {
		}

		return feedbackParams;
	}

	*//**
	 * 验证码请求参数
	 * 
	 * @param context
	 * @param giftpackId
	 *            空表示为注册接口
	 * @return
	 *//*
	public static String getGiftpackCodeParams(Context context,
			String giftpackId) {
		String giftpackCodeParams = "";
		Map<String, String> params = new HashMap<String, String>();
		String productid = GameBoxConfig.PRODUCT_ID;
		if (StringUtil.isEmpty(packetid)) {
			packetid = GameBoxConfig.getPacketID(context);
		}
		if (StringUtil.isEmpty(versionid)) {
			versionid = String.valueOf(DeviceInfo.getAppVersion(context));
		}
		if (StringUtil.isEmpty(sysuserid) || sysuserid.equals("0")) {
			sysuserid = String.valueOf(GameBoxApplication.getSysUserID());
		}
		if (StringUtil.isEmpty(devicekey)) {
			devicekey = GameBoxConfig.getDeviceKey();
		}

		if (StringUtil.isEmpty(devicecode)) {
			devicecode = DeviceInfo.getDeviceID(context);
		}

		String userid = "";
		if (!GameBoxApplication.getToken().isEmpty()) {
			UserInfoBean userInfoBean = GameBoxApplication.getUserInfo();
			if (userInfoBean != null) {
				userid = Long.toString(userInfoBean.getUserID());
			}
		}

		params.put("productid", productid); // 产品ID
		params.put("packetid", packetid); // 渠道包ID
		params.put("versionid", versionid); // 产品版本ID
		params.put("sysuserid", sysuserid); // 若sysuserid为0，则是首次使用，需要注册(BaseUser表)
		params.put("userid", userid);

		String type = "1";
		if (!StringUtil.isEmpty(giftpackId)) {
			type = "2";
			params.put("giftpackid", giftpackId);
		}
		params.put("devicecode", devicecode); // 设备号,iOS为mac
		params.put("type", type); // 验证码类型 1：用户注册，2：礼包领取
		params.put("devicekey", devicekey); // 客户端唯一标识,第一次初始化为空

		try {
			giftpackCodeParams = encodeUrl(params,
					GBResponseHandler.DEFAULT_ENCODING, true,
					GameBoxApplication.getEncryptKey());
		} catch (UnsupportedEncodingException e) {
		}

		return giftpackCodeParams;
	}*/

	private static String encodeUrl(Map<String, String> params, String enc,
			boolean encryption, String encryptkey)
			throws UnsupportedEncodingException {
		if (params == null) {
			return "";
		}
		StringBuilder sb = new StringBuilder();
		String value = "";
		for (Map.Entry<String, String> entry : params.entrySet()) {
			sb.append(entry.getKey());
			sb.append("=");
			value = entry.getValue();
			if (StringUtil.isEmpty(value)) {
				sb.append("");
			} else {
				sb.append(URLEncoder.encode(entry.getValue(), enc));
			}
			sb.append("&");
		}
		if (sb.length() > 0) {
			sb.deleteCharAt(sb.length() - 1);
		}
		String temp = sb.toString();

		if (encryption && !StringUtil.isEmpty(encryptkey)) {
			try {
				temp = AES.Encrypt(temp, encryptkey);
			} catch (Exception e) {
			}
		}
		return temp;
	}

/*	public static String getDeviceSystemID() {
		if (StringUtil.isEmpty(sysuserid) || sysuserid.equals("0")) {
			sysuserid = String.valueOf(GameBoxApplication.getSysUserID());
		}
		return sysuserid;
	}*/

}
