package cn.ewan.pushsdk.util;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

public class AES 
{
    public static String Decrypt(String sSrc, String sKey) throws Exception 
    {
    	try 
    	{
            if (sKey == null) 
            {
                System.out.print("Key为空null");
                return null;
            }
            //判断Key是否为16位
            if (sKey.length() != 16) 
            {
                System.out.print("Key长度不是16位");
                return null;
            }
            byte[] raw = sKey.getBytes("ASCII");
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec);
            byte[] encrypted1 = hex2byte(sSrc);
            try 
            {
                byte[] original = cipher.doFinal(encrypted1);
                String originalString = new String(original);
                return originalString;
            } 
            catch (Exception e) 
            {
                System.out.println(e.toString());
                return null;
            }
        } 
    	catch (Exception ex) 
    	{
            System.out.println(ex.toString());
            return null;
        }
    }
    //判断Key是否正确
    public static String Encrypt(String sSrc, String sKey) throws Exception 
    {
        if (sKey == null) 
        {
            System.out.print("Key为空null");
            return null;
        }
        //判断Key是否为16位
        if (sKey.length() != 16) 
        {
            System.out.print("Key长度不是16位");
            return null;
        }
        byte[] raw = sKey.getBytes("ASCII");
        SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        Cipher cipher = Cipher.getInstance("AES");
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
        byte[] encrypted = cipher.doFinal(sSrc.getBytes());
        return byte2hex(encrypted).toLowerCase();
    }
    
    public static byte[] hex2byte(String strhex) 
    {
        if (strhex == null) {
            return null;
        }
        int l = strhex.length();
        if (l % 2 == 1) {
            return null;
        }
        byte[] b = new byte[l / 2];
        for (int i = 0; i != l / 2; i++) {
            b[i] = (byte) Integer.parseInt(strhex.substring(i * 2, i * 2 + 2), 16);
        }
        return b;
    }
    
    public static String byte2hex(byte[] b) 
    {
        String hs = "";
        String stmp = "";
        for (int n = 0; n < b.length; n++) {
            stmp = (Integer.toHexString(b[n] & 0XFF));
            if (stmp.length() == 1) {
                hs = hs + "0" + stmp;
            } else {
                hs = hs + stmp;
            }
        }
        return hs.toUpperCase();
    }
    
//    public static void main(String[] args) throws Exception 
//    {
//    	String str = "测试test%$$$&&**&^%%$$$$$%123";
//    	String newStr = "0b2db28108b215c3f8ca4600a454a9b9dd08731524c56b0a48f05ada567597b843927817af2b538cdbcd4c600129c8fd";
//    	String key = "test1234567890&*";
//    	
//    	System.out.println(AES.Decrypt(newStr, key));
//    	System.out.println(AES.Encrypt(str, key));
//    }
}
