/*
 * 文件名: ErrorCode.java
 * 版    权：  Copyright iAround Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: turlet@163.com
 * 创建时间:2012-11-12
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.util;

import android.util.SparseArray;

/**
 * 错误码<BR>
 * [功能详细描述]
 * @author panyf
 * @version [RCS Client V100R001C03, 2016-3-31] 
 */
public class ErrorCode {
    
    /**
     * 请求业务并服务器处理返回成功
     */
    public static final int STATUS_SUCCESS_CODE = 1;
        
    /**
     * -1 参数错误
     */
    public static final int ERROR_PARAM = -1;
    
    /**
     * -2  请求时间戳不在有效期内
     */
    public static final int ERROR_TOKEN_TIMETICKET = -2;
        
    /**
     * -3 授权验签失败
     */
    public static final int ERROR_OAUTH_SIGN = -3;
    
    /**
     * -4   服务器连接不上错误
     */
    public static final int ERROR_SERVER_BUSY = -4;
    
    /**
     * -4   服务器连接不上错误
     */
    public static final int ERROR_NETWORD_DISCONNECT = -5;
    
    /**
     * 返回Json数据解析错误
     */
    public static final int ERROR_JSON_PARSE = 2002;
        
    /**
     * 保存错误码的提示信息
     */
    private static SparseArray<String> errorTip = new SparseArray<String>();
    
    static {
        errorTip.put(ERROR_SERVER_BUSY, "服务器繁忙.");
        errorTip.put(ERROR_OAUTH_SIGN, "授权失败.");        
        errorTip.put(ERROR_TOKEN_TIMETICKET, "登录验签时间戳失效.");
        errorTip.put(ERROR_PARAM, "参数错误");
        errorTip.put(ERROR_JSON_PARSE, "数据有误.");
        errorTip.put(ERROR_NETWORD_DISCONNECT, "无法连接网络.");
    }
    
    public static String getTip(int errorCode) {
        return errorTip.get(errorCode, "未知错误.");
    }
    
}
