/*
 * 文件名: StringUtil.java
 * 版    权：  Copyright Administrator Tech. Co. Ltd. All Rights Reserved.
 * 描    述: [该类的简要描述]
 * 创建人: 杨兴朗
 * 创建时间:2012-10-24
 * 
 * 修改人：
 * 修改时间:
 * 修改内容：[修改内容]
 */
package cn.ewan.pushsdk.util;

import java.util.Random;

/**
 * 字符串工具类<BR>
 * [功能详细描述]
 * @author 杨兴朗
 * @version [RCS Client V100R001C03, 2012-10-24] 
 */
public final class StringUtil {
    
    private static Random randGen = new Random();
    
    private static char[] numbersAndLetters = ("0123456789abcdefghijklmnopqrstuvwxyz" +
            "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ").toCharArray();
    
    public static String randomString(int length) {
        if (length < 1) {
            return null;
        }
        char [] randBuffer = new char[length];
        for (int i=0; i<randBuffer.length; i++) {
            randBuffer[i] = numbersAndLetters[randGen.nextInt(71)];
        }
        return new String(randBuffer);
    }
    
    /**
     * 字符串是否为空或为NUll<BR>
     * [功能详细描述]
     * @param str
     * @return
     */
    public static boolean isEmpty(String str){
        if (str == null || str.length() == 0 || "".equals(str))
            return true;
        else
            return false;
    }
    
    /**
     * [把Byte转换单位]<BR>
     * [功能详细描述]
     * @param size
     * @return
     */
    public static String convertSpace(long size){
        if(size < 1000){
            return String.valueOf((Math.round((float)size/1024*10))/(float)10) + "K";
        }else{
            return String.valueOf((Math.round((float)size/1024/1024*10))/(float)10) + "M";
        }
    }
    
    public static long parseLong(String data) {
        long parse = 0l;
        try{
            parse = Long.parseLong(data);
        }catch(NumberFormatException e){
            parse = 0l;
        }
        return parse;
    }
    
    public static int parseInt(String data) {
        int parse = 0;
        try{
            parse = Integer.parseInt(data);
        }catch(NumberFormatException e){
            parse = 0;
        }
        return parse;
    }
}
